%define with_python_version     2.4%{nil}
%define with_apidocs            1%{nil}

%define rpmhome /usr/lib/rpm

%define poptver 1.10.2.3

Summary: The RPM package management system
Name: rpm
Version: 4.4.2.3
Release: 22%{?dist}.2
Group: System Environment/Base
Url: http://www.rpm.org/
Source: http://rpm.org/releases/rpm-4.4.x/%{name}-%{version}.tar.gz
Patch1: rpm-4.4.2.3-prereq.patch
Patch2: rpm-4.4.2-ghost-conflicts.patch
Patch3: rpm-4.4.2-trust.patch
# Autogenerate dependencies from -devel package .so symlinks
Patch4: rpm-4.4.2.2-devel-autodep.patch
Patch5: rpm-4.4.2-rpmfc-skip.patch
# Better selinux support
Patch6: rpm-4.4.2.2-matchpathcon.patch
#Patch7: rpm-4.4.2.1-no-popt.patch
# Use NSS instead of beecrypt for lowlevel crypto
Patch8: rpm-4.4.2.3-nss.patch
Patch9: rpm-4.4.2.2-autofoo.patch
# Set pkg-config path correctly on multilib 
Patch10: rpm-4.4.2.2-pkgconfig-path.patch
#Patch11: rpm-4.4.2.3-queryformat-arch.patch
# Don't arbitrarily limit dependency loop rescans
Patch12: rpm-4.4.2.3-no-order-rescan-limit.patch
# Fix bug in rpm 4.4.2.3 external dependency extractor
Patch13: rpm-4.4.2.3-fix-find-requires.patch
# Fix compiler flags for sparc
Patch14: rpm-4.4.2.3-rc1-sparc-mcpu.patch
# Disable buggy ldconfig optimization
Patch15: rpm-4.4.2-ldconfig.patch
# RHEL 5 compiler toolchain doesn't generate build-id's, don't complain
Patch16: rpm-4.4.2.3-no-buildid-warning.patch
# Close all, not just first 100 file descriptors before running scripts
Patch17: rpm-4.4.2.3-cloexec.patch
# Ignore conflicts on doc files (for now)
Patch18: rpm-4.4.2.3-no-doc-conflicts.patch
# Japanese translation fixes (#250207, #387321)
Patch19: rpm-4.4.2.3-man-jp-fix.patch
Patch20: rpm-4.4.2.3-no-overweight-packages.patch
Patch21: rpm-4.4.2.3-urlcache.patch
Patch22: rpm-4.4.2.3-die-on-python-traceback.patch
Patch23: rpm-4.4.2.3-glob-errorcode.patch
Patch24: rpm-4.4.2.3-rpmds-nopromote.patch
# NSPR messes with SIGPIPE, restore default for --pipe and scriptlets
Patch25: rpm-4.4.2.3-sigpipe.patch
# Rip out RDTSC timer code causing floating point exceptions in xen on some hw
Patch26: rpm-4.4.2.3-rip-rdtsc.patch
# Filter out timestamp differences of shared files on verify
Patch27: rpm-4.4.2.3-verify-timestamp.patch
# Perform verify in real chroot if --root specified
Patch28: rpm-4.4.2.3-verify-chroot.patch
# Check arch compatibility on colored transactions too, except on ia64...
Patch29: rpm-4.4.2.3-arch-check.patch
# PGP fingerprint calculation fix (#493777)
Patch30: rpm-4.4.2.3-pgp-fingerprint.patch
# Support for default patch fuzz (#471005)
Patch31: rpm-4.4.2.3-patchfuzz.patch
# Pad RSA signatures to modulus size if necessary (#502791)
Patch32: rpm-4.4.2.3-rsa-sigpad.patch
# Some Intel-provided packages use em64t as arch instead of x86_64 (#511354)
Patch33: rpm-4.4.2.3-em64t-arch.patch
# SELinux mem-leak fix (#566746)
Patch34: rpm-4.4.2.3-selinux-leak.patch
# Fix CVE-2010-2059, rpm fails to drop SUID/SGID bits on package upgrade (#626708)
Patch35: rpm-4.4.2.3-remove-sbits.patch
# Multilib ordering fixes for #641892 and the umptheen duplicates:
# - return all file providers from rpmal to enable callers to pick and choose
# - order based on preferred color to get files laid down when needed
Patch36: rpm-4.4.2.3-rpmal-allfiles.patch
Patch37: rpm-4.4.2.3-colored-order.patch
# accept gpg-keys saved with notepad (#530212)
Patch38: rpm-4.4.2.3-gpg-keys-line-ending.patch

# Performance tweaks (#435475)
# Improved file fingerprinting hash algorithm
Patch40: rpm-4.4.2.3-fp-hash.patch
# Allocate in powers of two to avoid crazy memory fragmemtation
Patch41: rpm-4.4.2.3-dbi-index.patch
# Kill unnecessary allocations from rpmdsCompare() which gets called a *LOT*
Patch42: rpm-4.4.2.3-dscompare-tweak.patch
# fix handling of malformed header (#742156)
Patch43: rpm-4.4.2.3-header-sanity.patch

# RHEL 5 auto*foo are too old, just running autoreconf wont work
Patch50: rpm-4.4.2.3-autoreconf.patch

# XXX Beware, this is one murky license, partially GPL/LGPL dual-licensed
# and several different components with their own licenses included...
# SourceLicense: (GPLv2+ and LGPLv2+ with exceptions) and BSD and MIT and Sleepycat
License: GPLv2+

Requires(post): coreutils
Requires: crontabs
Requires: logrotate
Requires: rpm-libs = %{version}-%{release}
Requires: popt = %{poptver}-%{release}

# XXX generally assumed to be installed but make it explicit as rpm
# is a bit special...
BuildRequires: redhat-rpm-config
BuildRequires: gawk
BuildRequires: elfutils-devel >= 0.112
BuildRequires: readline-devel zlib-devel
BuildRequires: nss-devel
BuildRequires: sqlite-devel
BuildRequires: gettext-devel
BuildRequires: libselinux-devel
BuildRequires: ncurses-devel
BuildRequires: bzip2-devel >= 0.9.0c-2
BuildRequires: python-devel >= %{with_python_version}

BuildConflicts: neon-devel

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
The RPM Package Manager (RPM) is a powerful command line driven
package management system capable of installing, uninstalling,
verifying, querying, and updating software packages. Each software
package consists of an archive of files along with information about
the package like its version, a description, etc.

%package libs
Summary:  Libraries for manipulating RPM packages
Group: Development/Libraries
License: GPLv2+ and LGPLv2+ with exceptions
Requires: rpm = %{version}-%{release}
Requires: popt = %{poptver}-%{release}

%description libs
This package contains the RPM shared libraries.

%package devel
Summary:  Development files for manipulating RPM packages
Group: Development/Libraries
License: GPLv2+ and LGPLv2+ with exceptions
Requires: rpm = %{version}-%{release}
Requires: rpm-libs = %{version}-%{release}
Requires: nss-devel 
Requires: sqlite-devel
Requires: libselinux-devel
Requires: elfutils-libelf-devel
Requires: popt = %{poptver}-%{release}

%description devel
This package contains the RPM C library and header files. These
development files will simplify the process of writing programs that
manipulate RPM packages and databases. These files are intended to
simplify the process of creating graphical package managers or any
other tools that need an intimate knowledge of RPM packages in order
to function.

This package should be installed if you want to develop programs that
will manipulate RPM packages and databases.

%package build
Summary: Scripts and executable programs used to build packages
Group: Development/Tools
Requires: rpm = %{version}-%{release}
Requires: rpm-libs = %{version}-%{release}
Requires: popt = %{poptver}-%{release}
Requires: elfutils binutils
Requires: findutils sed grep gawk diffutils file patch >= 2.5
Requires: unzip gzip bzip2 cpio

%description build
The rpm-build package contains the scripts and executable programs
that are used to build packages using the RPM Package Manager.

%package python
Summary: Python bindings for apps which will manipulate RPM packages
Group: Development/Libraries
Requires: rpm-libs = %{version}-%{release}
Requires: rpm = %{version}-%{release}
Requires: popt = %{poptver}-%{release}

%description python
The rpm-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by RPM Package Manager libraries.

This package should be installed if you want to develop Python
programs that will manipulate RPM packages and databases.

%if %{with_apidocs}
%package apidocs
Summary: API documentation for RPM libraries
Group: Documentation
BuildRequires: doxygen

%description apidocs
This package contains API documentation for developing applications
that will manipulate RPM packages and databases.
%endif

%package -n popt
Summary: A C library for parsing command line parameters.
Group: Development/Libraries
Version: %{poptver}

%description -n popt
Popt is a C library for parsing command line parameters. Popt was
heavily influenced by the getopt() and getopt_long() functions, but it
improves on them by allowing more powerful argument expansion. Popt
can parse arbitrary argv[] style arrays and automatically set
variables based on command line arguments. Popt allows command line
arguments to be aliased via configuration files and includes utility
functions for parsing arbitrary strings into argv[] arrays using
shell-like rules.

%prep
%setup -q
%patch1 -p1 -b .prereq
%patch2 -p1 -b .ghostconflicts
%patch3 -p1 -b .trust
%patch4 -p1 -b .develdeps
%patch5 -p1 -b .fcskip
%patch6 -p1 -b .matchpathcon
%patch8 -p1 -b .nss
%patch9 -p1 -b .autofoo
%patch10 -p1 -b .pkgconfig-path
%patch12 -p1 -b .no-order-limit
%patch13 -p1 -b .requires
%patch14 -p1 -b .ldconfig
%patch15 -p1 -b .sparc-mcpu
%patch16 -p1 -b .no-buildid-warn
%patch17 -p1 -b .cloexec
%patch18 -p1 -b .no-doc-conflicts
%patch19 -p1 -b .jp-man
%patch20 -p1 -b .no-overweight-packages
%patch21 -p1 -b .urlcache
%patch22 -p1 -b .py-traceback
%patch23 -p1 -b .glob-errorcode
%patch24 -p1 -b .ds-nopromote
%patch25 -p1 -b .sigpipe
%patch26 -p1 -b .rip-rdtsc
%patch27 -p1 -b .verify-timestamp
%patch28 -p1 -b .verify-chroot
%patch29 -p1 -b .arch-check
%patch30 -p1 -b .pgp-fingerprint
%patch31 -p1 -b .patchfuzz
%patch32 -p1 -b .rsa-sigpad
%patch33 -p1 -b .em64t
%patch34 -p1 -b .selinux-leak
%patch35 -p1 -b .remove-sbits
%patch36 -p1 -b .rpmal-allfiles
%patch37 -p1 -b .colored-order
%patch38 -p1 -b .gpg-keys-line-ending

%patch40 -p1 -b .fp-hash
%patch41 -p1 -b .dbi-index
%patch42 -p1 -b .dscompare-tweak
%patch43 -p1 -b .header-sanity

%patch50 -p1 -b .autoreconf

%build

# XXX pull in updated config.guess and config.sub as done by %%configure
# which cannot be used to build rpm itself due to makefile brokenness
for i in $(find . -name config.guess -o -name config.sub) ; do 
    [ -f /usr/lib/rpm/redhat/$(basename $i) ] && %{__rm} -f $i && %{__cp} -fv /usr/lib/rpm/redhat/$(basename $i) $i 
done 

# XXX rpm 4.4.2.1 can't be built with %%configure due to makefile brokenness
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS
./configure --prefix=%{_usr} \
            --sysconfdir=%{_sysconfdir} \
            --localstatedir=%{_var} \
            --infodir=%{_infodir} \
            --mandir=%{_mandir} \
            --with-python=%{with_python_version} \
            --enable-posixmutexes

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR="$RPM_BUILD_ROOT" install

# Clean up useless symlinks
for i in rpme rpmi rpmu; do
    rm -f $RPM_BUILD_ROOT%{_bindir}/$i
done

# Save list of packages through cron
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.daily
install -m 755 scripts/rpm.daily ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.daily/rpm

mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
install -m 644 scripts/rpm.log ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/rpm

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rpm

mkdir -p $RPM_BUILD_ROOT/var/spool/repackage
mkdir -p $RPM_BUILD_ROOT/var/lib/rpm
for dbi in \
        Basenames Conflictname Dirnames Group Installtid Name Packages \
        Providename Provideversion Requirename Requireversion Triggername \
        Filemd5s Pubkeys Sha1header Sigmd5 \
        __db.001 __db.002 __db.003 __db.004 __db.005 __db.006 __db.007 \
        __db.008 __db.009
do
    touch $RPM_BUILD_ROOT/var/lib/rpm/$dbi
done

%find_lang %{name}
%find_lang popt

# copy db and file/libmagic license info to distinct names
cp -p db/LICENSE LICENSE-bdb
cp -p file/LEGAL.NOTICE LEGAL.NOTICE-file
cp -p lua/COPYRIGHT COPYRIGHT-lua

# Get rid of unpackaged files
{ cd $RPM_BUILD_ROOT
  rm -f .%{_libdir}/lib*.la
  rm -f .%{rpmhome}/{Specfile.pm,cpanflute,cpanflute2,rpmdiff,rpmdiff.cgi,sql.prov,sql.req,tcl.req,rpm.*}
  rm -rf .%{_mandir}/{fr,ko}
  rm -f .%{_libdir}/python%{with_python_version}/site-packages/*.{a,la}
  rm -f .%{_libdir}/python%{with_python_version}/site-packages/rpm/*.{a,la}
  rm -f .%{_libdir}/python%{with_python_version}/site-packages/rpmdb/*.{a,la}
}

find $RPM_BUILD_ROOT/%{_libdir}/python%{with_python_version} -name "*.py"|xargs chmod 644

%clean
rm -rf $RPM_BUILD_ROOT

%post
# XXX Detect (and remove) incompatible dbenv files during upgrade.
# XXX Removing dbenv files in %%post opens a lock race window, a tolerable
# XXX risk compared to the support issues involved with upgrading Berkeley DB.
[ -w /var/lib/rpm/__db.001 ] &&
/usr/lib/rpm/rpmdb_stat -CA -h /var/lib/rpm 2>&1 |
grep "db_stat: Program version ... doesn't match environment version" 2>&1 > /dev/null &&
        rm -f /var/lib/rpm/__db*
                                                                                
exit 0

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%define rpmdbattr %attr(0644, root, root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace)

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc CHANGES GROUPS COPYING LICENSE-bdb LEGAL.NOTICE-file CREDITS ChangeLog
%doc COPYRIGHT-lua doc/manual/[a-z]*

%{_sysconfdir}/cron.daily/rpm
%config(noreplace,missingok)    %{_sysconfdir}/logrotate.d/rpm
%dir                            %{_sysconfdir}/rpm
# XXX teach rpm to skip .rpmnew etc first...
#%ghost %config(noreplace,missingok)   %{_sysconfdir}/rpm/platform
#%ghost %config(noreplace,missingok)   %{_sysconfdir}/rpm/macros.tscolor

%dir /var/lib/rpm
%rpmdbattr /var/lib/rpm/*
%dir /var/spool/repackage
%dir %{rpmhome}

/bin/rpm
%{_bindir}/rpm2cpio
%{_bindir}/gendiff
%{_bindir}/rpmdb
%{_bindir}/rpmsign
%{_bindir}/rpmquery
%{_bindir}/rpmverify

%{rpmhome}/config.guess
%{rpmhome}/config.sub
%{rpmhome}/convertrpmrc.sh
%{rpmhome}/freshen.sh
%{rpmhome}/mkinstalldirs
%{rpmhome}/rpm2cpio.sh
%{rpmhome}/rpm[deiukqv]
%{rpmhome}/tgpg
%{rpmhome}/rpmdb_*
%{rpmhome}/rpmfile

%{rpmhome}/macros
%{rpmhome}/rpmpopt*
%{rpmhome}/rpmrc

%ifarch i386 i486 i586 i686 athlon geode pentium3 pentium4 x86_64
%{rpmhome}/i[3456]86*
%{rpmhome}/athlon*
%{rpmhome}/geode*
%{rpmhome}/pentium*
%endif
%ifarch alpha alphaev5 alphaev56 alphapca56 alphaev6 alphaev67
%{rpmhome}/alpha*
%endif
%ifarch sparc sparcv8 sparcv9 sparc64
%{rpmhome}/sparc*
%endif
%ifarch ia64
%{rpmhome}/ia64*
%endif
%ifarch powerpc ppc ppciseries ppcpseries ppcmac ppc64
%{rpmhome}/ppc*
%endif
%ifarch s390 s390x
%{rpmhome}/s390*
%endif
%ifarch %{arm}
%{rpmhome}/arm*
%endif
%ifarch mips mipsel
%{rpmhome}/mips*
%endif
%ifarch x86_64
%{rpmhome}/x86_64*
%{rpmhome}/amd64*
%{rpmhome}/ia32e*
%endif
%{rpmhome}/noarch*

%{_mandir}/man1/gendiff.1*
%{_mandir}/man8/rpm.8*
%{_mandir}/man8/rpm2cpio.8*

# XXX this places translated manuals to wrong package wrt eg rpmbuild
%lang(ja) %{_mandir}/ja/man[18]/*.[18]*
%lang(pl) %{_mandir}/pl/man[18]/*.[18]*
%lang(ru) %{_mandir}/ru/man[18]/*.[18]*
%lang(sk) %{_mandir}/sk/man[18]/*.[18]*

%files libs
%defattr(-,root,root)
%{_libdir}/librpm*-*.so

%files build
%defattr(-,root,root)
%{_usrsrc}/redhat
%{_bindir}/rpmbuild
%{rpmhome}/brp-*
%{rpmhome}/check-buildroot
%{rpmhome}/check-files
%{rpmhome}/check-prereqs
%{rpmhome}/check-rpaths*
%{rpmhome}/cross-build
%{rpmhome}/debugedit
%{rpmhome}/find-debuginfo.sh
%{rpmhome}/find-lang.sh
%{rpmhome}/find-prov.pl
%{rpmhome}/find-provides
%{rpmhome}/find-provides.perl
%{rpmhome}/find-req.pl
%{rpmhome}/find-requires
%{rpmhome}/find-requires.perl
%{rpmhome}/get_magic.pl
%{rpmhome}/getpo.sh
%{rpmhome}/http.req
%{rpmhome}/javadeps
%{rpmhome}/magic.prov
%{rpmhome}/magic.req
%{rpmhome}/mono-find-provides
%{rpmhome}/mono-find-requires
%{rpmhome}/osgideps.pl
%{rpmhome}/perldeps.pl
%{rpmhome}/perl.prov
%{rpmhome}/perl.req
%{rpmhome}/pythondeps.sh
%{rpmhome}/rpm[bt]
%{rpmhome}/rpmdeps
%{rpmhome}/trpm
%{rpmhome}/u_pkg.sh
%{rpmhome}/vpkg-provides.sh
%{rpmhome}/vpkg-provides2.sh

%{rpmhome}/config.site
%{rpmhome}/magic
%{rpmhome}/magic.mgc
%{rpmhome}/magic.mime
%{rpmhome}/magic.mime.mgc

%{_mandir}/man8/rpmbuild.8*
%{_mandir}/man8/rpmdeps.8*

%files python
%defattr(-,root,root)
%{_libdir}/python%{with_python_version}/site-packages/rpm

%files devel
%defattr(-,root,root)
%{_includedir}/rpm
%{_libdir}/librp*[a-z].so
%{_libdir}/librp*[a-z].a
%{_mandir}/man8/rpmcache.8*
%{_mandir}/man8/rpmgraph.8*
%{rpmhome}/rpmcache
%{_bindir}/rpmgraph

%if %{with_apidocs}
%files apidocs
%defattr(-,root,root)
%doc apidocs
%endif

%files -n popt -f popt.lang
%defattr(-,root,root)
%doc popt/COPYING popt/CHANGES popt/README
%{_libdir}/libpopt.so.*
%{_libdir}/libpopt.a
%{_libdir}/libpopt.so
%{_includedir}/popt.h
%{_mandir}/man3/popt.3*

%changelog
* Fri Sep 30 2011 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-22.2
- fix thinko in the CVE backport

* Thu Sep 29 2011 Jindrich Novy <jnovy@redhat.com> - 4.4.2.3-22.1
- fix CVE-2011-3378 (#742156)

* Tue Nov 16 2010 Jindrich Novy <jnovy@redhat.com> - 4.4.2.3-22
- accept windows cr/lf line endings in gpg keys (#530212)

* Tue Nov 16 2010 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-21
- Backport multilib ordering fixes from rpm 4.8.x (#641892)

* Mon Aug 30 2010 Jindrich Novy <jnovy@redhat.com> - 4.4.2.3-20
- make the sbits removal behavior consistent with all the RHELs

* Thu Aug 26 2010 Jindrich Novy <jnovy@redhat.com> - 4.4.2.3-19
- fix CVE-2010-2059, fails to drop SUID/SGID bits on package upgrade (#626708)
- fix SELinux memory leak (#566746), patch from Florian Festi

* Fri Jul 24 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-18
- Really fix #511354

* Tue Jul 21 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-17
- Treat em64t architecture as an alias for x86_64 (#511354)

* Wed Jul 1 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-16
- Disable dependency caching chroot'ed verify (#508074)

* Wed Jun 17 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-15
- pad RSA signatures to modulus size if necessary (#502791)

* Thu May 07 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-14
- small fix to Japanese translation (#387321)

* Wed May 06 2009 Jindrich Novy <jnovy@redhat.com> - 4.4.2.3-13
- backport default patch fuzz feature from upstream (#471005)
Resolves: #471005

* Tue Apr 21 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-12
- fix pgp fingerprint calculation (#493777)
- performance tweaks (#435475)
  - better hash algorithm to speed up initial install
  - avoid crazy memory fragmentation on file fingerprinting
  - eliminate unnecessary allocations from rpmdsCompare() hotpath

* Wed Mar 18 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-11
- dont abort build if debugedit fails (#482903)

* Mon Feb 02 2009 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-10
- Filter out timestamp differences of shared files on verify (#472151)
- Perform verification in real chroot if --root specified (#434150)
- Check for arch compatibility on colored transactions too (#472065)

* Tue Dec 02 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-9
- Remove RDTSC timer code causing floating point exceptions on xen (#472467)

* Wed Nov 19 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-8
- Restore default SIGPIPE for scriptlets and --pipe (#471591)

* Wed Oct 15 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-7
- Fix exit code on file not found errors (#463944, #446202)
- Always honor epoch (no)promote behavior in dependency sets (#466503)

* Fri Oct 03 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-6
- Abort transaction on traceback in python callback (#463999)

* Fri Sep 19 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-5
- Disallow creation of packages larger than we can cleanly handle (#448488)
- Fix retrieval of multiple packages through proxy (#450205)

* Tue Sep 02 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-4
- Temporarily permit conflicts in /usr/share/doc/ (#460808)
- Fix --dump usage description in Japanese manual too (#250207)

* Fri Aug 22 2008 Jindrich Novy <jnovy@redhat.com> - 4.4.2.3-3
- rpm-libs requires popt, add corresponding Requires:
- Related: #454887

* Thu Aug 14 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-2
- Close all file descriptors before running scriptlets (#453645)
- Tighten up dependencies between sub-packages

* Tue Aug 12 2008 Panu Matilainen <pmatilai@redhat.com> - 4.4.2.3-1
- Rebase to RPM 4.4.2.3 from F9 (#454887)
- Much cleaned up spec
- NSS used instead of beecrypt for lowlevel crypto (#444805)
- Provides no longer treated as implicit obsoletes (#233713, #348971)
- Use root:root for file ownerships everywhere (#439417)
- Improved .rpmsave/.rpmnew behavior (#426258)
- Exit code corrections (#244236, #440595)
- Improved multilib build support (#257921)
- Improved debuginfo extraction (#251333)
- Dozens of other issues resolved

* Thu Sep 20 2007 Panu Matilainen <pmatilai@redhat.com> -  4.4.2-48
- Don't show errors twice on non-existent files (#215712)
- Update scriptlet names to match what's available (#248128)

* Fri Aug 24 2007 Panu Matilainen <pmatilai@redhat.com> -  4.4.2-47
- disable ldconfig optimizations (#253492)

* Mon Aug 20 2007 Panu Matilainen <pmatilai@redhat.com> -  4.4.2-46
- Rebuild due to apparent builroot temporary hickup to really fix #211119

* Mon Aug 06 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-45
- Create x86_64 compat macros for ia32e and amd64 (#211119)

* Wed Jun 27 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-44
- Fix typo in script 

* Wed Jun 27 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-43
- Group multilb packages patch from jbj (#220348,#225074,#225077)

* Tue Jun 26 2007 Panu Matilainen <pmatilai@redhat.com> -  4.4.2-42
- actually apply the multiple installs patch (#213399)

* Tue Jun 26 2007 Panu Matilainen <pmatilai@redhat.com> -  4.4.2-41
- permit multiple versions of a package to be installed within a transaction
  with -i (#213399)

* Thu Jun 21 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-40
- Update replaced state in transaction (#237478)

* Mon Jun 18 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-39
- Preserve replaced state in transaction (#237478)

* Mon Jun 04 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-38
- Update userlock patch for potential segfault (#231146)

* Thu Jan 04 2007 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-37
- Build without neon (#213055)

* Mon Nov 20 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-36
- Fix ordering issues (#214865)

* Tue Oct 31 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-35
- Flush query buffer patch from jbj (#212833)

* Tue Oct 31 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-34
- Debuginfo extraction with O0

* Wed Oct 25 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-33
- Fix for ordering (#202540, #202542, #202543, #202544)

* Thu Sep 07 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-32
- Various debuginfo fixes (#165434, #165418, #149113, #205339)

* Fri Jul 21 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-31
- Apply matchpathcon patch

* Wed Jul 19 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-30
- Fix debugedit for ppc relocations (#199473)

* Fri Jul 14 2006 David Cantrell <dcantrell@redhat.com> - 4.4.2-29
- Fixed null pointer problem in rpmfcELF() DT_GNU_HASH handling

* Tue Jul 11 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-28
- Detect and provide a requirement for DT_GNU_HASH 

* Wed Jul 05 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-27
- IPv4/6 and EPSV support by Arkadiusz Miskiewicz <misiek@pld.org.pl>

* Wed Jun 28 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-26
- Force CHANGELOGTIME to be a list in rpm-python

* Wed Jun 28 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-25
- Remove SELinux context verification (#193488)

* Thu May 04 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-24
- File classification with autoReq off (#190488)

* Thu May  4 2006 Jeremy Katz <katzj@redhat.com> - 4.4.2-23
- make rpm-libs requires on base package stronger

* Wed May  3 2006 Jeremy Katz <katzj@redhat.com> - 4.4.2-22
- put in simple workaround for per-file deps with autoreq off (#190488) 
  while pnasrat works on a real fix

* Fri Apr 28 2006 Jeremy Katz <katzj@redhat.com> - 4.4.2-21
- run ldconfig in -libs subpackage %%post, not main package
- add patch to generate shared lib deps by following symlinks so that 
  -devel packages sanely depend on main libs

* Thu Apr 27 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-20
- Update --trusted stubs for rpmk breakage

* Tue Apr 25 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-19
- Add --trusted stubs from upstream

* Wed Apr 12 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-18
- Resurrect doxygen (#187714)

* Tue Apr 11 2006 Jeremy Katz <katzj@redhat.com> - 4.4.2-17
- remove redundant elfutils-libelf buildrequires
- rpm-python doesn't require elfutils (related to #188495)

* Fri Mar 31 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-16
- Skipdirs on erase again (#187308)
- Make fcntl lock sensitive to --root (#151255)
- Fix netshared path comparison (#52725)
- Fix rpm vercmp (#178798)

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 4.4.2-15.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 4.4.2-15.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Jan 30 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-15
- Rebuild for newer neon
- Fix scriptlet deadlock (#146549)

* Wed Jan 18 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-14
- Don't emit perl(main) (#177960)

* Wed Jan 11 2006 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-13
- Don't mmap large files

* Mon Jan  9 2006 Alexander Larsson <alexl@redhat.com> - 4.4.2-12
- Add mono req/provides support

* Thu Dec 01 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-11
- Remove rpm .la files (#174261)
- Cron job use paths (#174211)

* Tue Nov 29 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-10
- Ignore excluded size (#89661)

* Tue Nov 29 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-9
- Don't skipDirs on erasures (#140055)

* Mon Nov 28 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-8
- Add elfutils Build Requires to rpmbuild (#155129)
- Don't do conflicts if both files %ghost(#155256)
- Fix popt charset for various languages (#172155)
- Don't include .la file (#174261)

* Tue Nov  8 2005 Tomas Mraz <tmraz@redhat.com> - 4.4.2-7
- rebuilt with new openssl

* Sun Oct 09 2005 Florian La Roche <laroche@redhat.com>
- rebuild for sqlite changes

* Thu Sep 22 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-5
- Actually fix context verification where matchpathcon fails (#162037)

* Fri Aug 26 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-4
- Fix build with CFLAGS having --param
- Fix for context verification in /tmp (#162037)

* Wed Jul 27 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-3
- popt minor version requires

* Tue Jul 26 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-2
- popt minor version bump
- revert to perl.req/perl.prov for now

* Thu Jul 21 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.2-1
- Upgrade to upstream release

* Tue May 24 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-21
- Update translations (#154623)

* Sat May 21 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-20
- Drop signature patch
- dangling unpackaged symlinks

* Tue May 17 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-19
- Check for symlinks in check-files (#108778)
- Move zh_CN (#154623)
- Test fix for signing old rpms (#127113)

* Wed May 04 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-18.1
- Fix typo
- Fix typo

* Wed May 04 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-18
- Add missing fsm.c from matchpathcon patches 

* Tue May 03 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-17
- Fix typo

* Tue May 03 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-16
- Yet more matchpathcon

* Tue May 03 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-15
- Some more matchpathcon work

* Mon May 02 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-14
- matchpathcon fixup

* Mon May 02 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-13
- Use matchpathcon (#151870)

* Sat Apr 30 2005 Miloslav Trmac <mitr@redhat.com> - 4.4.1-12
- Remove $RPM_BUILD_ROOT and $RPM_BUILD_DIR from distribued .la files (#116891)
- Don't ship static version of _rpmdb.so
- BuildRequires: readline-devel

* Wed Apr 27 2005 Paul Nasrat <pnasrat@redhat.com> - 4.4.1-11
- Fix for (pre,postun) (#155700)
- Erase ordering

* Wed Apr 27 2005 Jeremy Katz <katzj@redhat.com> - 4.4.1-10
- add patch to fix segfault with non-merged hdlists

* Thu Mar 31 2005 Thomas Woerner <twoerner@redhat.com> 4.4.1-9
- enabled prereqs again

* Mon Mar 21 2005 Paul Nasrat <pnasrat@redhat.com> 4.4.1-8
- Add devel requires libselinux-devel
- Fileconflicts as FC3 (#151609)

* Wed Mar  9 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-7
- rebuild against renamed sqlite package (#149719).

* Mon Mar  7 2005 Jeremy Katz <katzj@redhat.com> - 4.4.1-6
- fix build with new glibc

* Mon Mar  7 2005 Jeremy Katz <katzj@redhat.com> - 4.4.1-5
- disable hkp by default

* Tue Mar  1 2005 Jeremy Katz <katzj@redhat.com> - 4.4.1-4
- fix build with gcc 4

* Mon Feb 28 2005 Jeremy Katz <katzj@redhat.com> - 4.4.1-3
- fix posttrans callback check being backwards (#149524)

* Sun Feb 13 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-1
- don't classify files in /dev (#146623).
- don't build with sqlite3 if <sqlite3.h> is missing.

* Sat Feb 12 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.24
- zlib: uniqify certain symbols to prevent name space pollution.
- macosx: include <sys/types.h> so that python sees the u_char typedef.
- macosx: change to --prefix=/usr rather than /opt/local.
- use waitpid rather than SIGCHLD reaper.
- rip out DB_PRIVATE revert if not NPTL, it's not the right thing to do.

* Fri Feb 11 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.22
- permit build scriptlet interpreters to be individually overridden.

* Thu Feb 10 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.20
- perform callbacks as always (#147537).

* Wed Feb  2 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.16
- fix: length of gpg V4 hash seed was incorrect (#146896).
- add support for V4 rfc-2440 signatures.

* Mon Jan 31 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.14
- add sqlite internal (build still expects external sqlite3-3.0.8).
- sqlite: revert to original narrow scoping of cOpen/cClose.

* Fri Jan 28 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.12
- python: force dbMatch() h# key to be 32 bit integer (#146477).

* Tue Jan 25 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.10
- more macosx fiddles.
- move global /var/lock/rpm/transaction to dbpath.
- permit fcntl path to be configured through rpmlock_path macro.
- add missing #if defined(ENABLE_NLS) (#146184).

* Mon Jan 17 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.8
- changes to build on Mac OS X using darwinports neon/beecrypt.
- add https://svn.uhulinux.hu/packages/dev/zlib/patches/02-rsync.patch

* Sun Jan  9 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.7
- build against external/internal neon.

* Tue Jan  4 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.6
- mac os x patches (#131943,#131944,#132924,#132926).
- mac os x patches (#133611, #133612, #134637).

* Sun Jan  2 2005 Jeff Johnson <jbj@jbj.org> 4.4.1-0.5
- upgrade to db-4.3.27.
- revert MAGIC_COMPRESS, real fix is in libmagic (#143782).
- upgrade to file-4.12 internal.

* Tue Dec  7 2004 Jeff Johnson <jbj@jbj.org> 4.4.1-0.3
- use package color as Obsoletes: color.

* Mon Dec  6 2004 Jeff Johnson <jbj@jbj.org> 4.4.1-0.2
- automagically detect and emit "python(abi) = 2.4" dependencies.
- popt 1.10.1 to preserve newer.

* Sun Dec  5 2004 Jeff Johnson <jbj@jbj.org> 4.4.1-0.1
- force *.py->*.pyo byte code compilation with brp-python-bytecompile.
